#
#       HBS REDUCTION SUB ROUTINE
#
#       extract 4 two-dimensional spectra reffering an image
#                                               : hbsapext.cl
#
#       1997/07/15      K.Kawabata  Ver. 1.00
#       1998/02/06      K.Kawabata  ver. 2.00
#
#
#    !!! WARNING: File name must not be included '.imh' !!!
#

procedure hbsapext( infile, refdir, outfile1, outfile2, outfile3, outfile4, yp1, yp2, yp3, yp4 )

string infile { prompt = "Input image" }
string refdir { prompt = "Directroy of 1to1-FIT data" }
string outfile1 { prompt = "Output image Sp1" }
string outfile2 { prompt = "Output image Sp2" }
string outfile3 { prompt = "Output image Sp3" }
string outfile4 { prompt = "Output image Sp4" }
int    yp1 { prompt = "Extraction start point of SP1" }
int    yp2 { prompt = "Extraction end point of SP1" }
int    yp3 { prompt = "Extraction start point of SP2" }
int    yp4 { prompt = "Extraction end point of SP2" }

begin

  file fn
  file fn1, fn2, fn3, fn4
  string tmp1, tmp2, tmp3, tmp4
  string rdir
  int y1, y2, y3, y4

  rdir = refdir
  fn = infile
  fn1 = outfile1
  fn2 = outfile2
  fn3 = outfile3
  fn4 = outfile4
  y1 = yp1
  y2 = yp2
  y3 = yp3
  y4 = yp4

  tmp1 = mktemp( "hbs.tmp.image." )
  tmp2 = mktemp( "hbs.tmp.image." )
  tmp3 = mktemp( "hbs.tmp.image." )
  tmp4 = mktemp( "hbs.tmp.image." )

  printf( "Transforming Y.." )
  hbsscy( fn, rdir, tmp1, tmp2 )
  printf( " X.." )
  hbsscx( tmp1, tmp2, rdir, tmp3, tmp4 )
  printf( "  extracting..." )
  imcopy( tmp3//"[*,"//y1//":"//y2//"]", fn1, ver- )
  imcopy( tmp4//"[*,"//y1//":"//y2//"]", fn2, ver- )
  imcopy( tmp3//"[*,"//y3//":"//y4//"]", fn3, ver- )
  imcopy( tmp4//"[*,"//y3//":"//y4//"]", fn4, ver- )

  imdelete( tmp1, ver- )
  imdelete( tmp2, ver- )
  imdelete( tmp3, ver- )
  imdelete( tmp4, ver- )

  hbscoord( fn1 )
  hbscoord( fn2 )
  hbscoord( fn3 )
  hbscoord( fn4 )
  printf( "  Done.\n", fn4 )

end
