#
#       HBS REDUCTION ROUTINE
#
#       overwrite header file refering to cryolist.dat: hbsreheader.cl
#
#       1997/12/12      K.Kawabata  Ver.0.10 (cryofits3.c)
#

procedure hbsreheader

begin

  file listoflist = "cryolist.dat"
  file tmp_list1, tmp_list2, tmp_list3
  string fn[2000]
  string fn1, obj, datatype, diaphrag, clump, filter
  int n_datatype, n_diaph, n_clump
  real poshwp, slit
  int i, n_list
  string buf1, buf2, buf3

  if( access( listoflist ) == 0 )
  {
    print( "Cannot find "//listoflist )
    bye
  }

  tmp_list1 = "cryolist.da1"
  tmp_list2 = "cryolist.da2"
  tmp_list3 = "cryolist.da3"

  if( access( tmp_list1 ) == 1 )
    delete( tmp_list1, ver- )
  if( access( tmp_list2 ) == 1 )
    delete( tmp_list2, ver- )
  if( access( tmp_list3 ) == 1 )
    delete( tmp_list3, ver- )

#  sed( '/^[^C^c]/   y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/', listoflist, >> tmp_list1 )
  !sed '/^[^C^c]/   y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' cryolist.dat > cryolist.da1
  sed( 's/^C/c/', tmp_list1, >> tmp_list2 )
  sed( 's/\.fts/\./', tmp_list2, >> tmp_list3 )

#----- Scanning the list file

  n_list = 0
  list = tmp_list3
  while( fscan(list, fn1, obj, buf1, poshwp, buf2, slit, buf3, filter ) != EOF )
  {
    if( fn1 == "#" )
      next
    n_list += 1
    fn[n_list] = fn1
  }

#---- selection of images for summation

  list = listoflist

  for( i=1; i<=n_list; i+=1 )
  {
    fn1 = fn[i]
    c =  fscan(list, fn1, obj, buf1, poshwp, buf2, slit, buf3, filter )
    if( fn1 == "#" ){
      i=i-1
      next
    }
    n_datatype = int( buf1 )
    n_diaph = int( buf2 )
    n_clump = int( buf3 )
    switch( n_datatyp )
    {
      case 1:
        datatype = "OBJECT"
        break
      case 2:
        datatype = "DARK"
        break
      case 3:
        datatype = "COMPARISON"
        break
      case 4:
        datatype = "BIAS"
        break
      case 5:
        datatype = "FLAT"
        break
      case 6:
        datatype = "NEARBY_SKY"
        break
      default:
        datatype = "????"
    }
    switch( n_diaph ){
      case 1:
        diaphrag = "1HOLE"
        break
      case 3:
        diaphrag = "2HOLES_UPPER"
        break
      case 2:
        diaphrag = "2HOLES_LOWER"
        break
      case 5:
        diaphrag = "2SLIT01_UPPER"
        break
      case 4:
        diaphrag = "2SLIT01_LOWER"
        break
      case 7:
        diaphrag = "2SLIT02_UPPER"
        break;
      case 6:
        diaphrag = "2SLIT02_LOWER"
        break;
      case 8:
        diaphrag = "1SLIT004"
        break;
    }
    switch( n_clump ){
      case 1:
        clump = "WEST"
        break
      case 2:
        clump = "EAST"
    }
    if( filter == "0" )
      filter = "NO_FILTER"
    if( filter == "1" )
      filter = "GT"

    fn1 = fn[i]//"*.imh"
    printf( "%s %10s %6.2f %s\n", fn[i], datatyp, poshwp, diaphrag )

    hedit( fn1,  "DATA-TYP", datatype, add+, delete-, verify-, show-, update+ )
    hedit( fn1,  "POS-HWP", poshwp, add+, delete-, verify-, show-, update+ )
    hedit( fn1,  "TEL-POSE", clump, add+, delete-, verify-, show-, update+ )
    hedit( fn1,  "FILTER", filter, add+, delete-, verify-, show-, update+ )
    hedit( fn1,  "SLIT-WID", slit, add+, delete-, verify-, show-, update+ )
    hedit( fn1,  "DIAPHRAG", diaphrag, add+, delete-, verify-, show-, update+ )
    hedit( fn1,  "HBSTITLE", obj, add+, delete-, verify-, show-, update+ )
    
  }

#  delete( tmp_list1, ver- )
#  delete( tmp_list2, ver- )
#  delete( tmp_list3, ver- )

end
